--- ztd-loc.c.orig	Tue Aug 24 12:13:13 2004
+++ ztd-loc.c	Tue Aug 24 12:16:22 2004
@@ -154,6 +154,13 @@
 		cur = cur->next;
 	}
 	spin_unlock_irqrestore(&zlock, flags);
+	if (cur == z) {
+		printk("TDMoL: Removed interface for %s, key %d id %d\n", z->span->name, z->key, z->id);
+#ifndef LINUX26
+		MOD_DEC_USE_COUNT;
+#endif
+		kfree(z);
+	}
 }
 
 /*static*/ void *ztdlocal_create(struct zt_span *span, char *address)
@@ -216,6 +223,9 @@
 		z->next = zdevs;
 		zdevs = z;
 		spin_unlock_irqrestore(&zlock, flags);
+#ifndef LINUX26
+		MOD_INC_USE_COUNT;
+#endif
 
 		printk("TDMoL: Added new interface for %s, key %d id %d\n", span->name, z->key, z->id);
 	}
